function write_parms_txt_file(p,filename)

    fileID = fopen(filename,'wt'); % wt: open in text mode
    
    fprintf(fileID,'rra: %g\n',p.rra);
    fprintf(fileID,'beta: %g\n',p.beta);
    fprintf(fileID,'clb: %g\n',p.clb);
    fprintf(fileID,'ggq_mDval: %g\n',p.ggq_mDval);
    fprintf(fileID,'ggq_mlb: %g\n',p.ggq_mlb);
    fprintf(fileID,'ggq_mub: %g\n',p.ggq_mub);
    fprintf(fileID,'ggq_mmean: %g\n',p.ggq_mmean);
    fprintf(fileID,'ggq_mstd: %g\n',p.ggq_mstd);
    fprintf(fileID,'d_y: %g\n',p.d_y);
    fprintf(fileID,'d_yy: %g\n',p.d_yy);
    fprintf(fileID,'d_b: %g\n',p.d_b);
    fprintf(fileID,'d_bb: %g\n',p.d_bb);
    fprintf(fileID,'d_yb: %g\n',p.d_yb);
    fprintf(fileID,'errtol_bisect: %g\n',p.errtol_bisect);
    fprintf(fileID,'maxiters_bisect: %g\n',p.maxiters_bisect);
    fprintf(fileID,'rH: %g\n',p.rH);
    fprintf(fileID,'rL: %g\n',p.rL);
    fprintf(fileID,'holding_cost: %g\n',p.holding_cost);
    fprintf(fileID,'prob_liqshock: %g\n',p.prob_liqshock);
    fprintf(fileID,'prob_meet_mkt_maker_ND: %g\n',p.prob_meet_mkt_maker_ND);
    fprintf(fileID,'prob_meet_mkt_maker_D: %g\n',p.prob_meet_mkt_maker_D);
    fprintf(fileID,'bargain_power_mkt_maker_ND: %g\n',p.bargain_power_mkt_maker_ND);
    fprintf(fileID,'bargain_power_mkt_maker_D: %g\n',p.bargain_power_mkt_maker_D);
    fprintf(fileID,'debt_z: %g\n',p.debt_z);
    fprintf(fileID,'debt_m: %g\n',p.debt_m);
    fprintf(fileID,'debt_writedown_reentry: %g\n',p.debt_writedown_reentry);
    fprintf(fileID,'max_def_prob: %g\n',p.max_def_prob);
    fprintf(fileID,'recovery_bmax: %g\n',p.recovery_bmax);
%     fprintf(fileID,'issuance_cost: %g\n',p.issuance_cost);
%     fprintf(fileID,'cost_qviolation: %g\n',p.cost_qviolation);
%     fprintf(fileID,'max_debt_buyback: %g\n',p.max_debt_buyback);
    fprintf(fileID,'reenterprob: %g\n',p.reenterprob);
    fprintf(fileID,'gridsize_tfp: %g\n',p.gridsize_tfp);
    fprintf(fileID,'gridsize_b: %g\n',p.gridsize_b);
    fprintf(fileID,'bmax: %g\n',p.bmax);
    fprintf(fileID,'tfp_lb: %g\n',p.tfp_lb);
    fprintf(fileID,'tfp_ub: %g\n',p.tfp_ub);
    fprintf(fileID,'conv_chk_tfp_lb: %g\n',p.conv_chk_tfp_lb);
    fprintf(fileID,'conv_chk_tfp_ub: %g\n',p.conv_chk_tfp_ub);
    fprintf(fileID,'conv_chk_b_ub: %g\n',p.conv_chk_b_ub);
    fprintf(fileID,'sigma_tfp: %g\n',p.sigma_tfp);
    fprintf(fileID,'rho_tfp: %g\n',p.rho_tfp);
    fprintf(fileID,'maxiters: %g\n',p.maxiters);
    fprintf(fileID,'errtolV: %g\n',p.errtolV);
    fprintf(fileID,'errtolQ: %g\n',p.errtolQ);
    fprintf(fileID,'NumUpdateRegimes: %g\n',p.NumUpdateRegimes);
    write_vector_short(fileID,'UpdateRegimeIter',p.UpdateRegimeIter);
    write_vector_short(fileID,'UpdateWeightOldV',p.UpdateWeightOldV);
    write_vector_short(fileID,'UpdateWeightOldQ',p.UpdateWeightOldQ);
    write_vector_short(fileID,'UpdateWeightOldDefProb',p.UpdateWeightOldDefProb);
    
    fclose(fileID);
    
end

function write_vector_short(fID,sname,x)

    if numel(x)>1
        for i = 1:numel(x)
            if i==1
                fprintf(fID,'%s: %g/',sname,x(1));
            elseif i<numel(x)
                fprintf(fID,'%g/',x(i));
            else
                fprintf(fID,'%g\n',x(i));
            end
        end
    else
        fprintf(fID,'%s: %g\n',sname,x(1));
    end

end

function write_vector_long(fID,sname,x)

    if numel(x)>1
        for i = 1:numel(x)
            if i==1
                fprintf(fID,'%s: %.12f/',sname,x(1));
            elseif i<numel(x)
                fprintf(fID,'%.12f/',x(i));
            else
                fprintf(fID,'%.12f\n',x(i));
            end
        end
    else
        fprintf(fID,'%s: %.12f\n',sname,x(1));
    end

end