function conv_outputs = ConvertCPPtoMAT(p,model_outputs)
% input is from running 
% outputs = mexSolveModelGivenParms(parm_struc, useDevice, DisplayInterval)
    
    conv_outputs.iter = model_outputs.iter;
    conv_outputs.err_qH_ND = model_outputs.err_qH_ND;
    conv_outputs.err_qL_ND = model_outputs.err_qL_ND;
    conv_outputs.err_qH_D = model_outputs.err_qH_D;
    conv_outputs.err_qL_D = model_outputs.err_qL_D;
    conv_outputs.err_defprob = model_outputs.err_defprob;
    conv_outputs.err_CVD = model_outputs.err_CVD;
    conv_outputs.err_CVND = model_outputs.err_CVND;
    conv_outputs.CVD = permute(reshape(model_outputs.CVD,[p.gridsize_b p.gridsize_mpr p.gridsize_tfp]),[3 2 1]);
    conv_outputs.CVND = permute(reshape(model_outputs.CVND,[p.gridsize_b p.gridsize_mpr p.gridsize_tfp]),[3 2 1]);
    conv_outputs.qNDH = permute(reshape(model_outputs.qH_ND,[p.gridsize_b p.gridsize_mpr p.gridsize_tfp]),[3 2 1]);
    conv_outputs.qNDL = permute(reshape(model_outputs.qL_ND,[p.gridsize_b p.gridsize_mpr p.gridsize_tfp]),[3 2 1]);
    conv_outputs.qDH = permute(reshape(model_outputs.qH_D,[p.gridsize_b p.gridsize_mpr p.gridsize_tfp]),[3 2 1]);
    conv_outputs.qDL = permute(reshape(model_outputs.qL_D,[p.gridsize_b p.gridsize_mpr p.gridsize_tfp]),[3 2 1]);
    conv_outputs.defprob = permute(reshape(model_outputs.defprob,[p.gridsize_b p.gridsize_mpr p.gridsize_tfp]),[3 2 1]);
    conv_outputs.defthresh = permute(reshape(model_outputs.defthresh,[p.gridsize_b p.gridsize_mpr p.gridsize_tfp]),[3 2 1]);
    conv_outputs.idx_bchoice = permute(reshape(model_outputs.idx_bchoice+1,[p.gridsize_b p.gridsize_mpr p.gridsize_tfp]),[3 2 1]);
    conv_outputs.prob_y = permute(reshape(model_outputs.prob_y,[p.gridsize_tfp p.gridsize_tfp]),[2 1]);
    conv_outputs.prob_mpr = permute(reshape(model_outputs.prob_mpr,[p.gridsize_mpr p.gridsize_mpr]),[2 1]);
    conv_outputs.prob_RN_y_mpr_ynext = permute(reshape(model_outputs.prob_RN_y_mpr_ynext,[p.gridsize_tfp p.gridsize_mpr p.gridsize_tfp]),[3 2 1]);
    conv_outputs.grid_y_nd = model_outputs.grid_y_nd;
    conv_outputs.grid_y_d = model_outputs.grid_y_d;
    conv_outputs.grid_mpr = model_outputs.grid_mpr;

end