#ifndef TAUCHEN_H
#define TAUCHEN_H

#include "realtype.h"

int tauchen1d(REAL_TYPE *x, REAL_TYPE *Px, const REAL_TYPE mu, const REAL_TYPE rho, const REAL_TYPE sigma, const int N, const REAL_TYPE xlb, const REAL_TYPE xub);

int ContructGrids(REAL_TYPE *z, REAL_TYPE *x, REAL_TYPE *Pz, REAL_TYPE *Px, REAL_TYPE *Pzx, REAL_TYPE *Qzx, const REAL_TYPE rhoz, const REAL_TYPE sigmaz,
	const REAL_TYPE meanx, const REAL_TYPE rhox, const REAL_TYPE sigmax, const REAL_TYPE corr_shock, const int Nz, const int Nx, const REAL_TYPE stdwidth_z, const REAL_TYPE stdwidth_x);

int ContructGrids_efficient(REAL_TYPE *z, REAL_TYPE *x, REAL_TYPE *Pz, REAL_TYPE *Px, REAL_TYPE *Qzx_znext, const REAL_TYPE rhoz, const REAL_TYPE sigmaz, 
	const REAL_TYPE meanx, const REAL_TYPE rhox, const REAL_TYPE sigmax, const REAL_TYPE corr_shock, const int Nz, const int Nx, const REAL_TYPE stdwidth_z, const REAL_TYPE stdwidth_x);

#endif