clear all
close all
clc
set(0,'DefaultFigureWindowStyle','docked')
addpath(genpath('../matlab'))
addpath('../src_mex')

%% solve model without liquidity

load('baseline_no_liq_11042020.mat','p_no_liq','model_no_liq');

load('baseline_11042020.mat','p','model');

%% compute bond prices

% [qND_noliq,qD_noliq] = CalcBondPrices_noliq(p,default_threshold_eps,debt_policy)

tic
q_b0_d1_noliq = CalcBondPrices_noliq(p_no_liq,model.defthresh,model_no_liq.policy);
toc
q_b1_d0_noliq = CalcBondPrices_noliq(p_no_liq,model_no_liq.defthresh,model.policy);
toc


save('decomposition.mat','q_b0_d1_noliq','q_b1_d0_noliq')